package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Activator;
import com.vendor.burn.Messages;
import com.vendor.burn.model.FileSystem;
import com.vendor.burn.model.FlashType;
import com.vendor.burn.model.PartitionInfo;
import com.vendor.burn.model.PartitionItem;
import com.vendor.burn.model.PlatformType;
import com.vendor.burn.model.ProductLine;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.devices.IDeviceSetting;
import com.vendor.burn.model.devices.IFileSystemSetting;
import com.vendor.burn.model.devices.IFlashSetting;
import com.vendor.burn.model.devices.IPartitionBurner;
import com.vendor.burn.model.devices.ISaveable;
import com.vendor.burn.model.devices.burners.AbstractBurner;
import com.vendor.burn.model.devices.unknown.UnknownDevice;
import com.vendor.burn.model.event.EventType;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.model.event.IFastbootEventListener;
import com.vendor.burn.model.exceptions.InvalidElementException;
import com.vendor.burn.model.exceptions.InvalidFileSystemException;
import com.vendor.burn.packagers.nand.FlashOption;
import com.vendor.burn.packagers.nand.NandImageDialog;
import com.vendor.burn.packagers.nand.ip.NandIPCommon;
import com.vendor.burn.ui.BurnComposite;
import com.vendor.burn.ui.dialog.SelectNandImageDialog;
import com.vendor.burn.utilitily.FileUtils;
import com.vendor.burn.utilitily.ToolUtils;
import com.vendor.burn.views.FastbootView;
import com.vendor.platform.api.statistics.ToolStatistics;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.SAXReader;
import org.dom4j.io.XMLWriter;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.jobs.IJobChangeListener;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.layout.TableColumnLayout;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.CellLabelProvider;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.ColumnLayoutData;
import org.eclipse.jface.viewers.ColumnPixelData;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.ComboBoxCellEditor;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.jface.viewers.ICheckStateListener;
import org.eclipse.jface.viewers.IContentProvider;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.osgi.util.NLS;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Drawable;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.ScrollBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;
import org.vendor.preferences.BurnState;
import org.xml.sax.SAXException;

public class PartitionComposite extends BurnComposite implements ISaveable, IFastbootEventListener {
  protected static final String DATA_EDITOR = "EDITOR";
  
  protected static final String DATA_EDITOR_JUM = "EDITOR_JUM";
  
  protected static final String DATA_DISPOSELISTNER_JUM = "DISPOSELISTNER_JUM";
  
  protected static final String DATA_DISPOSELISTNER = "DISPOSELISTNER";
  
  private static String saveNandImgPath;
  
  private static final String SELECT_File = "SelectFile";
  
  protected static final int COL_SEL = 0;
  
  protected static final int COL_NAME = 1;
  
  protected static final int COL_SELECT_FILE = 2;
  
  protected static final int COL_FLASH_TYPE = 3;
  
  protected static final int COL_FILE_SYSTEM = 4;
  
  protected static final int COL_START = 5;
  
  protected static final int COL_LENGTH = 6;
  
  protected static final int COL_JUMP = 7;
  
  protected static final int COL_ADD = 8;
  
  private static final String[] COLUMNS = new String[] { Messages.PartitionComposite_TABLE_COLOMN_SEL, Messages.PartitionComposite_TABLE_COLOMN_NAME, Messages.PartitionComposite_TABLE_COLOMN_FILE, Messages.PartitionComposite_TABLE_COLOMN_FLASHTYPE, Messages.PartitionComposite_TABLE_COLOMN_FILESYSTEM, Messages.PartitionComposite_TABLE_COLOMN_START, Messages.PartitionComposite_TABLE_COLOMN_LENGTH, Messages.PartitionComposite_TABLE_COLOMN_JUMP, Messages.PartitionComposite_TABLE_COLOMN_ADD };
  
  boolean isDirty = false;
  
  int labelWidth = 0;
  
  private File partitionFile;
  
  protected CheckboxTableViewer itemViewer;
  
  protected boolean vBarVisibility = false;
  
  protected Button burnButton;
  
  protected Text tableFileText;
  
  private ComboBoxCellEditor fileSystemEditor;
  
  private ComboBoxCellEditor flashTypeEditor;
  
  private Button eraseButton;
  
  private Button eraseAllButton;
  
  private Button browseButton;
  
  private Button makeNandImageButton;
  
  protected Button saveButton;
  
  protected Button createUsbPackageButton;
  
  protected Button useXMLPathAsParentButton;
  
  protected Text programmerFileText;
  
  protected Button programmerFileBrowseButton;
  
  private TabItem tabItem;
  
  private CheckboxTableViewer viewer;
  
  public PartitionComposite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
    Activator.getDefault().add(this);
  }
  
  public boolean isDirty() {
    return this.isDirty;
  }
  
  protected boolean isSamePartitionItems(List<PartitionItem> l0, List<PartitionItem> l2) {
    if (l0.size() != l2.size())
      return false; 
    for (int i = 0; i < l2.size(); i++) {
      if (!((PartitionItem)l0.get(i)).partitionItemEquals(l2.get(i)))
        return false; 
    } 
    return true;
  }
  
  protected void createContents(Composite parent) {
    parent.setLayout((Layout)new FillLayout());
    Composite com = new Composite(parent, 0);
    com.setLayout((Layout)new GridLayout(6, false));
    GridData gridData = new GridData(1808);
    com.setLayoutData(gridData);
    this.useXMLPathAsParentButton = new Button(com, 32);
    GridData layoutData = new GridData(1, 1, false, false);
    this.useXMLPathAsParentButton.setLayoutData(layoutData);
    this.useXMLPathAsParentButton
      .setText(Messages.PartitionComposite_LABEL_Default_Use_XML_Path);
    this.useXMLPathAsParentButton.addListener(13, (Listener)new Object(this));
    this.useXMLPathAsParentButton.setSelection(true);
    Label label = new Label(com, 0);
    layoutData = new GridData(1, 1, false, false);
    layoutData.horizontalIndent = 20;
    label.setLayoutData(layoutData);
    label.setText(Messages.PartitionComposite_LABEL_PARTITION_FILE);
    this.tableFileText = new Text(com, 2048);
    GridData tableFileTextGD = new GridData(4, 1, true, false);
    tableFileTextGD.horizontalIndent = 5;
    tableFileTextGD.horizontalSpan = 2;
    this.tableFileText.setLayoutData(tableFileTextGD);
    this.tableFileText.addListener(14, (Listener)new Object(this));
    this.browseButton = new Button(com, 0);
    layoutData = new GridData(1, 1, false, false);
    ToolUtils.setWidthForOS(layoutData, 60, 70);
    this.browseButton.setLayoutData(layoutData);
    this.browseButton.setText(LABEL_BROWSE);
    this.browseButton.addListener(13, (Listener)new Object(this));
    this.saveButton = new Button(com, 0);
    this.saveButton.setLayoutData(layoutData);
    this.saveButton.setText(LABEL_SAVE);
    this.saveButton.addListener(13, (Listener)new Object(this));
    if (getBurner().getBurnContext().getPlatformType() == PlatformType.CA || ((UnknownDevice)
      getBurner().getBurnContext()
      .getDeviceSetting()).isSupportBurnByLibBootrom()) {
      Button alignButton = new Button(com, 32);
      layoutData = new GridData(1, 1, false, false);
      alignButton.setLayoutData(layoutData);
      alignButton
        .setText(Messages.PartitionComposite_LABEL_Default_Use_XML_Path);
      alignButton.setVisible(false);
      Label programmerFileLabel = new Label(com, 0);
      programmerFileLabel
        .setText(Messages.PartitionComposite_LABEL_PROGRAMER_FILE);
      GridData programmerLblGD = new GridData(1, 1, false, false);
      programmerLblGD.horizontalIndent = 15;
      programmerFileLabel.setLayoutData(programmerLblGD);
      this.programmerFileText = new Text(com, 2048);
      GridData programmerTextGD = new GridData(4, 1, true, false);
      programmerTextGD.horizontalIndent = 5;
      programmerTextGD.horizontalSpan = 2;
      this.programmerFileText.setLayoutData(programmerTextGD);
      this.programmerFileText.addModifyListener((ModifyListener)new Object(this));
      this.programmerFileBrowseButton = new Button(com, 0);
      layoutData = new GridData(1, 1, false, false);
      layoutData.horizontalSpan = 2;
      ToolUtils.setWidthForOS(layoutData, 125, 145);
      this.programmerFileBrowseButton.setLayoutData(layoutData);
      this.programmerFileBrowseButton.setText(LABEL_BROWSE);
      this.programmerFileBrowseButton.addListener(13, (Listener)new Object(this));
    } 
    createButtons(com);
    Control tableControl = createItemTable(com);
    this.itemViewer = (CheckboxTableViewer)tableControl.getData();
    this.itemViewer.setInput(getBurner());
    GridData layoutData2 = new GridData(4, 4, true, true, 6, 1);
    tableControl.setLayoutData(layoutData2);
    initData();
  }
  
  protected void createButtons(Composite parent) {
    Composite buttonComp = new Composite(parent, 0);
    buttonComp.setLayout((Layout)new GridLayout(5, true));
    GridData gd = new GridData();
    gd.horizontalSpan = 6;
    buttonComp.setLayoutData(gd);
    this.burnButton = new Button(buttonComp, 0);
    this.burnButton.setText(LABEL_BURN);
    GridData layoutData = new GridData(576);
    layoutData.widthHint = 120;
    this.burnButton.setLayoutData(layoutData);
    this.burnButton.addListener(13, (Listener)new Object(this));
    this.eraseButton = new Button(buttonComp, 0);
    this.eraseButton.setText(LABEL_ERASE);
    layoutData = new GridData(576);
    layoutData.widthHint = 120;
    this.eraseButton.setLayoutData(layoutData);
    this.eraseButton.addListener(13, (Listener)new Object(this));
    this.eraseAllButton = new Button(buttonComp, 0);
    this.eraseAllButton.setText(Messages.EmmcComposite_EmmcEraseAll);
    layoutData = new GridData(576);
    layoutData.widthHint = 120;
    this.eraseAllButton.setLayoutData(layoutData);
    this.eraseAllButton.addListener(13, (Listener)new Object(this));
    if (!FastbootView.isHideCreateNandBurnerImage()) {
      this.makeNandImageButton = new Button(buttonComp, 0);
      this.makeNandImageButton.setText(LABEL_MAKE_NAND_IMAGE);
      layoutData = new GridData(576);
      ToolUtils.setWidthForOS(layoutData, 200, 160);
      this.makeNandImageButton.setLayoutData(layoutData);
      this.makeNandImageButton.addListener(13, (Listener)new Object(this));
    } 
    if (ToolUtils.getProductLine() != ProductLine.PRODUCTLINE.CAM) {
      buttonComp.setLayoutData(new GridData(4, 1, true, false, 4, 1));
      return;
    } 
    this.createUsbPackageButton = new Button(buttonComp, 0);
    this.createUsbPackageButton.setText(LABEL_CREATE_USB_PACKAGE);
    layoutData = new GridData(576);
    ToolUtils.setWidthForOS(layoutData, 200, 160);
    this.createUsbPackageButton.setLayoutData(layoutData);
    this.createUsbPackageButton.addListener(13, (Listener)new Object(this));
    buttonComp.setLayoutData(new GridData(4, 1, true, false, 4, 1));
  }
  
  protected void handleCreateProUsb(IFastbootProgressMonitor fastbootMonitor, String filePath, String fileName) throws FileNotFoundException {
    fastbootMonitor.getEvent().init(EventType.CREATE_USB_PACKAGE);
    Object object = new Object(this, "Create USB package", filePath, fastbootMonitor, fileName);
    object.setUser(true);
    object.schedule();
  }
  
  private boolean createPartitionXmlForProUsb(String tempDirectoryPath) {
    String partitionFilePath = tempDirectoryPath + "\\partition.xml";
    try {
      this.partitionFile = new File(partitionFilePath);
      if (this.partitionFile.exists())
        FileUtils.deleteFile(this.partitionFile); 
      boolean isCreate = FileUtils.isCreateNewFile(this.partitionFile);
      if (!isCreate) {
        MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", 
            NLS.bind(Messages.AddressBurnerWorker_PartFile_Create_Failed, this.partitionFile.getPath()));
        return false;
      } 
      if (this.partitionFile == null || !this.partitionFile.exists()) {
        MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.UanbleParseXml);
        return false;
      } 
      getPartitionXml(this.partitionFile, getBurner().getPratitionInfo().getChildren());
      SAXReader reader = new SAXReader();
      Document document = null;
      try {
        reader.setFeature("http://apache.org/xml/features/disallow-doctype-decl", true);
      } catch (SAXException e) {
        return false;
      } 
      document = reader.read(this.partitionFile);
      Element root = document.getRootElement();
      for (Iterator<?> parent = root.elementIterator("Part"); parent.hasNext(); ) {
        Element part = (Element)parent.next();
        Attribute attribute = part.attribute("SelectFile");
        String strSelectFile = part.attributeValue("SelectFile");
        int lastIndexOf = strSelectFile.lastIndexOf("\\");
        if (lastIndexOf == -1)
          lastIndexOf = strSelectFile.lastIndexOf("/"); 
        String newSelctFile = strSelectFile.substring(lastIndexOf + 1);
        attribute.setValue(newSelctFile);
      } 
      OutputFormat format = OutputFormat.createPrettyPrint();
      XMLWriter writer = null;
      writer = new XMLWriter(new OutputStreamWriter(new FileOutputStream(partitionFilePath), "GB2312"), format);
      format.setEncoding("GB2312");
      writer.write(document);
      writer.close();
    } catch (DocumentException e) {
      Display.getDefault().syncExec((Runnable)new Object(this));
      return false;
    } catch (IOException e) {
      Display.getDefault().syncExec((Runnable)new Object(this, e));
      return false;
    } 
    return true;
  }
  
  public static void getPartitionXml(File tableFile, List<PartitionItem> children) {
    OutputStream out = null;
    try {
      out = new FileOutputStream(tableFile);
      out.write("<?xml version=\"1.0\" encoding=\"GB2312\" ?>\n".getBytes("GB2312"));
      out.write("<Partition_Info>\n".getBytes("GB2312"));
      for (PartitionItem item : children)
        out.write(item.toString().getBytes("GB2312")); 
      out.write("</Partition_Info>\n".getBytes("GB2312"));
    } catch (FileNotFoundException fileNotFoundException) {
    
    } catch (IOException iOException) {
    
    } finally {
      if (out != null)
        try {
          out.close();
        } catch (IOException iOException) {} 
    } 
  }
  
  protected String getCreateImageButtonCaption() {
    return Messages.PartitionComposite_ButtonCaption_CreateImage;
  }
  
  protected void createImage() {
    IPartitionBurner burner = getBurner();
    if (checkStatus(burner.checkCreateImage())) {
      IFastbootProgressMonitor monitor = getProgressMonitor();
      monitor.getEvent().setBurner((IBurner)getBurner());
      burner.createImage(monitor);
    } else {
      enableButtons();
    } 
  }
  
  protected void initData() {
    IPartitionBurner burner = getBurner();
    IDeviceSetting deviceSetting = burner.getBurnContext().getDeviceSetting();
    IFlashSetting flashSetting = deviceSetting.getFlashSetting();
    String[] flashNames = flashSetting.getFlashNames((IBurner)burner);
    this.flashTypeEditor.setItems(flashNames);
    String[] fileSystemNames = deviceSetting.getFileSystemSetting().getFileSystemNames((IBurner)burner);
    this.fileSystemEditor.setItems(fileSystemNames);
  }
  
  protected void handleEnterOnTableFileText() {
    if (this.tableFileText == null || this.tableFileText.isDisposed())
      return; 
    String text = this.tableFileText.getText().trim();
    File file = new File(text);
    if (!file.exists()) {
      handleBrowseFile();
    } else {
      loadPartitionFile(file, this.useXMLPathAsParentButton.getSelection());
    } 
  }
  
  protected void handlePaintTableItem(Event event) {
    event.detail &= 0xFFFFFFDF;
    if ((event.detail & 0x2) == 0)
      return; 
    Table table = (Table)event.widget;
    int clientWidth = (table.getClientArea()).width;
    GC gc = event.gc;
    Color oldForeground = gc.getForeground();
    Color oldBackground = gc.getBackground();
    Color forecolor = new Color(null, new RGB(255, 0, 0));
    gc.setForeground(forecolor);
    gc.drawRectangle(0, event.y, clientWidth, event.height - 2);
    forecolor.dispose();
    gc.setForeground(oldForeground);
    gc.setBackground(oldBackground);
    event.detail &= 0xFFFFFFFD;
  }
  
  protected void handleBrowseFile() {
    FileDialog dialog = new FileDialog(getShell(), 4096);
    dialog.setFilterExtensions(new String[] { "*.xml" });
    String text = this.tableFileText.getText();
    if (!text.equals(""))
      dialog.setFileName(text); 
    String filePath = dialog.open();
    if (filePath != null) {
      this.tableFileText.setText(filePath);
      File tableFile = new File(filePath);
      if (tableFile.exists())
        loadPartitionFile(tableFile, this.useXMLPathAsParentButton
            .getSelection()); 
    } 
    promptToSave(false);
  }
  
  protected void loadPartitionFile(File tableFile, boolean xmlPathDefault) {
    try {
      PartitionInfo info = PartitionItem.load(tableFile, xmlPathDefault);
      List<PartitionItem> load = info.getChildren();
      if (load.isEmpty())
        throw new DocumentException(); 
      IPartitionBurner burner = getBurner();
      IDeviceSetting deviceSetting = burner.getBurnContext().getDeviceSetting();
      IFlashSetting flashSetting = deviceSetting.getFlashSetting();
      IFileSystemSetting fileSystemSetting = deviceSetting.getFileSystemSetting();
      List<FileSystem> fileSystems = Arrays.asList(fileSystemSetting
          .getFileSystems((IBurner)burner));
      List<FlashType> flashes = Arrays.asList(flashSetting
          .getFlashTypes((IBurner)burner));
      if (burner instanceof com.vendor.burn.model.devices.IEmmcBurner) {
        for (int i = 0; i < load.size(); i++) {
          PartitionItem part = load.get(i);
          if (part.getLength() == -1L && i != load.size() - 1 && 
            i != load.size() - 1)
            throw new InvalidElementException(
                NLS.bind(Messages.PartitionComposite_PartitionInvalidLength_For_PARTITION, new String[] { part.getName() })); 
          if (!flashes.contains(part.getFlashType()))
            throw new InvalidElementException(
                NLS.bind(Messages.PartitionComposite_FlashTypeUnsupported, new String[] { part.getName() })); 
          if (!fileSystems.contains(part.getFileSystem()))
            throw new InvalidFileSystemException(
                NLS.bind(Messages.PartitionComposite_FileSystemUnsupported, new String[] { part.getName() })); 
        } 
      } else {
        for (int i = 0; i < load.size(); i++) {
          PartitionItem part = load.get(i);
          if (part.getLength() < 0L && 
            i != load.size() - 1)
            throw new InvalidElementException(
                NLS.bind(Messages.PartitionComposite_PartitionInvalidLength_For_PARTITION, new String[] { part.getName() })); 
          if (!flashes.contains(part.getFlashType()))
            throw new InvalidElementException(
                NLS.bind(Messages.PartitionComposite_FlashTypeUnsupported, new String[] { part.getName() })); 
          if (!fileSystems.contains(part.getFileSystem()))
            throw new InvalidFileSystemException(
                NLS.bind(Messages.PartitionComposite_FileSystemUnsupported, new String[] { part.getName() })); 
        } 
      } 
      PartitionInfo partitionInfo = getBurner().getPratitionInfo();
      File programmerFile = info.getProgrammerFile();
      if (this.programmerFileText != null)
        if (programmerFile != null) {
          this.programmerFileText.setText(programmerFile.getPath());
          getBurner().getPratitionInfo().setProgrammerFile(programmerFile);
        } else {
          this.programmerFileText.setText("");
          getBurner().getPratitionInfo().setProgrammerFile(null);
        }  
      List<PartitionItem> children = partitionInfo.getChildren();
      boolean overwrite = true;
      if (children.size() > 1 && !isSamePartitionItems(load, children))
        overwrite = MessageDialog.openConfirm(
            Display.getDefault().getActiveShell(), Messages.FASTBOOT_CONFIRM_Title, Messages.PartitionComposite_msg_Make_sure_to_overwrite_partitions); 
      if (overwrite) {
        children.clear();
        children.addAll(load);
        getBurner().setTableFile(tableFile);
        this.itemViewer.refresh();
        updateSelection();
      } 
    } catch (DocumentException e) {
      MessageDialog.openWarning(
          Display.getDefault().getActiveShell(), Messages.FASTBOOT_WARNING_Title, Messages.PartitionComposite_msg_invalid_partition_file_please_check_the_file);
    } catch (InvalidFileSystemException e) {
      MessageDialog.openWarning(Display.getDefault().getActiveShell(), Messages.FASTBOOT_WARNING_Title, e
          
          .getMessage());
    } catch (InvalidElementException e) {
      MessageDialog.openWarning(Display.getDefault().getActiveShell(), Messages.FASTBOOT_WARNING_Title, e
          
          .getMessage());
    } 
    this.isDirty = false;
  }
  
  protected void updateSelection() {
    TableItem[] items = this.itemViewer.getTable().getItems();
    for (TableItem tableItem : items) {
      PartitionItem data = (PartitionItem)tableItem.getData();
      tableItem.setChecked(data.isChecked());
    } 
  }
  
  protected Control createItemTable(Composite parent) {
    Composite control = new Composite(parent, 2048);
    TableColumnLayout tcl = new TableColumnLayout();
    control.setLayout((Layout)tcl);
    this.viewer = CheckboxTableViewer.newCheckList(control, 66064);
    this.viewer.setContentProvider(createContentProvider());
    this.viewer.setLabelProvider(createLabelProvider());
    Table table = this.viewer.getTable();
    table.setHeaderVisible(true);
    table.setLinesVisible(true);
    table.addListener(42, (Listener)new Object(this));
    TableColumn column = new TableColumn(table, 16777216, 0);
    column.setImage(Activator.getImage("icons/check.bmp"));
    column.setResizable(false);
    column.setMoveable(true);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnPixelData(35, false));
    column.addListener(13, (Listener)new Object(this));
    this.viewer.addCheckStateListener((ICheckStateListener)new Object(this));
    table.addDisposeListener((DisposeListener)new Object(this));
    int minWeidth = 35;
    column = new TableColumn(table, 16777216, 1);
    column.setResizable(true);
    column.setMoveable(true);
    column.setText(COLUMNS[1]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(2, 35, false));
    column = new TableColumn(table, 16384, 2);
    column.setResizable(true);
    column.setMoveable(true);
    column.setText(COLUMNS[2]);
    column.setAlignment(131072);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(8, 35, false));
    column = new TableColumn(table, 16777216, 3);
    column.setResizable(true);
    column.setMoveable(true);
    column.setText(COLUMNS[3]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(2, 35, false));
    column = new TableColumn(table, 16777216, 4);
    column.setResizable(true);
    column.setMoveable(true);
    column.setText(COLUMNS[4]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(2, 35, false));
    column = new TableColumn(table, 16777216, 5);
    column.setResizable(true);
    column.setMoveable(true);
    column.setText(COLUMNS[5]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(1, 35, false));
    column = new TableColumn(table, 16777216, 6);
    column.setResizable(true);
    column.setMoveable(true);
    column.setText(COLUMNS[6]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(1, 35, false));
    TableColumn jumpCol = null;
    boolean needJumpFunction = ((this.burner instanceof com.vendor.burn.model.devices.burners.PartitionBurner || this.burner instanceof com.vendor.burn.model.devices.burners.CommonBurner) && !(this.burner instanceof com.vendor.burn.model.devices.burners.EmmcBurner) && !(this.burner instanceof com.vendor.burn.model.devices.burners.MergeBurner));
    if (needJumpFunction) {
      jumpCol = new TableColumn(table, 16777216, 7);
      jumpCol.setAlignment(16777216);
      jumpCol.setMoveable(true);
      jumpCol.setResizable(false);
      jumpCol.setText(COLUMNS[7]);
      tcl.setColumnData((Widget)jumpCol, (ColumnLayoutData)new ColumnPixelData(70, false));
      TableViewerColumn jumpColumn = new TableViewerColumn((TableViewer)this.viewer, jumpCol);
      jumpColumn.setLabelProvider((CellLabelProvider)new Object(this));
      setTableItemHeight(table, 25);
      TableEditor jumpEditor = new TableEditor(table);
      jumpEditor.horizontalAlignment = 16384;
      jumpEditor.grabHorizontal = true;
      jumpEditor.minimumWidth = 50;
      this.viewer.addSelectionChangedListener((ISelectionChangedListener)new Object(this, jumpEditor, table));
    } 
    TableColumn addCol = null;
    if (jumpCol == null) {
      addCol = new TableColumn(table, 16777216, 7);
    } else {
      addCol = new TableColumn(table, 16777216, 8);
    } 
    addCol.setAlignment(16777216);
    addCol.setMoveable(true);
    addCol.setResizable(false);
    addCol.setImage(Activator.getImage("icons/add.jpg"));
    tcl.setColumnData((Widget)addCol, (ColumnLayoutData)new ColumnPixelData(50, false));
    addCol.addListener(13, (Listener)new Object(this, control));
    TableViewerColumn addColumn = new TableViewerColumn((TableViewer)this.viewer, addCol);
    addColumn.setLabelProvider((CellLabelProvider)new Object(this));
    setTableItemHeight(table, 25);
    TableEditor addEditor = new TableEditor(table);
    addEditor.horizontalAlignment = 16384;
    addEditor.grabHorizontal = true;
    addEditor.minimumWidth = 50;
    this.viewer.addSelectionChangedListener((ISelectionChangedListener)new Object(this, addEditor, table));
    table.addListener(11, (Listener)new Object(this, table, control));
    ScrollBar verticalBar = table.getVerticalBar();
    if (verticalBar != null)
      setvBarVisibility(this.vBarVisibility); 
    this.viewer.setColumnProperties(COLUMNS);
    this.viewer.setCellModifier((ICellModifier)new Object(this));
    TextCellEditor nameEditor = new TextCellEditor((Composite)table);
    this
      .flashTypeEditor = new ComboBoxCellEditor((Composite)table, FlashType.getItems((IBurner)getBurner()), 8);
    this
      .fileSystemEditor = new ComboBoxCellEditor((Composite)table, FileSystem.getItems((IBurner)getBurner()), 8);
    TextCellEditor startEditor = new TextCellEditor((Composite)table);
    TextCellEditor lengthEditor = new TextCellEditor((Composite)table);
    Object object = new Object(this, (Composite)table);
    this.viewer.setCellEditors(new CellEditor[] { null, (CellEditor)nameEditor, (CellEditor)object, (CellEditor)this.flashTypeEditor, (CellEditor)this.fileSystemEditor, (CellEditor)startEditor, (CellEditor)lengthEditor, null });
    control.setData(this.viewer);
    return (Control)control;
  }
  
  protected FastbootEvent getEvent() {
    return null;
  }
  
  protected long getChipSize() {
    return 0L;
  }
  
  protected void handleAddNewPartition() {
    StructuredSelection selection = (StructuredSelection)this.itemViewer.getSelection();
    int index = 0;
    FlashType flashType = null;
    List<PartitionItem> children = getBurner().getPratitionInfo().getChildren();
    if (!selection.isEmpty()) {
      PartitionItem firstElement = (PartitionItem)selection.getFirstElement();
      flashType = firstElement.getFlashType();
      index = children.indexOf(firstElement);
    } else if (children.size() > 0) {
      PartitionItem partitionItem = children.get(children.size() - 1);
      flashType = partitionItem.getFlashType();
    } 
    IDeviceSetting deviceSetting = getBurner().getBurnContext().getDeviceSetting();
    IFlashSetting flashSetting = deviceSetting.getFlashSetting();
    if (flashType == null)
      flashType = flashSetting.getFlashTypes((IBurner)getBurner())[0]; 
    PartitionItem newItem = new PartitionItem();
    IFileSystemSetting fileSystemSetting = deviceSetting.getFileSystemSetting();
    FileSystem[] fileSystems = fileSystemSetting.getFileSystems((IBurner)getBurner());
    newItem.setFileSystem(fileSystems[0]);
    newItem.setFlashType(flashType);
    if (children.size() == 0) {
      newItem.setStart(0L);
      children.add(0, newItem);
    } else {
      PartitionItem lastPartition = children.get(index);
      newItem.setStart(lastPartition.getStart() + (
          (lastPartition.getLength() < 0L) ? 0L : 
          lastPartition.getLength()));
      children.add(++index, newItem);
    } 
    updateAddressesForAddNew(newItem, index);
    this.isDirty = true;
    promptToSave(false);
    this.itemViewer.refresh();
    this.itemViewer.setSelection((ISelection)new StructuredSelection(newItem), true);
  }
  
  protected IBaseLabelProvider createLabelProvider() {
    return (IBaseLabelProvider)new ViewerLabelProvider(this);
  }
  
  protected IContentProvider createContentProvider() {
    return (IContentProvider)new ViewerContentProvider();
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(4, false);
  }
  
  protected boolean isAllChecked() {
    Object[] checkedElements = this.itemViewer.getCheckedElements();
    return (checkedElements.length == getBurner().getPratitionInfo().getChildren().size());
  }
  
  protected void savePartitionTable() {
    File out = getPartitionFilePath(getBurner().getPartitionFile());
    if (out == null)
      return; 
    int open = 1;
    try {
      while (out != null && out.exists() && open == 1) {
        MessageDialog dialog = new MessageDialog(getShell(), Messages.FASTBOOT_MessageDialog_Title, null, NLS.bind(Messages.PartitionComposite_msg_file_exists_already_whether_to_overwrite_it, out
              
              .getCanonicalPath()), 6, new String[] { IDialogConstants.YES_LABEL, IDialogConstants.NO_LABEL }, 0);
        open = dialog.open();
        if (open == 1)
          out = getPartitionFilePath(getBurner().getPartitionFile()); 
      } 
      if (out == null || open == 2)
        return; 
      if (!out.exists())
        out.createNewFile(); 
      PartitionItem.save(out, getBurner().getPratitionInfo());
      this.tableFileText.setText(out.getCanonicalPath());
    } catch (IOException iOException) {}
    getBurner().setPartitionFile(out);
    this.isDirty = false;
  }
  
  protected File getPartitionFilePath(File partitionFile) {
    FileDialog dialog = new FileDialog(getShell(), 8192);
    dialog.setFilterExtensions(new String[] { "*.xml" });
    dialog.setFilterNames(new String[] { Messages.BurnComposite_Save_Filter_XML });
    File file = null;
    if (partitionFile != null) {
      try {
        dialog.setFilterPath(partitionFile.getCanonicalPath());
      } catch (IOException e) {
        return file;
      } 
      dialog.setFileName(partitionFile.getName());
    } 
    String open = dialog.open();
    if (open == null)
      return null; 
    file = new File(open);
    return file;
  }
  
  protected void setTableItemHeight(Table table, int height) {
    int itemHeight = table.getItemHeight();
    if (itemHeight == height)
      return; 
    try {
      Method setHeightMethod = Table.class.getDeclaredMethod("setItemHeight", new Class[] { int.class });
      setHeightMethod.setAccessible(true);
      setHeightMethod.invoke(table, new Object[] { Integer.valueOf(height) });
    } catch (SecurityException securityException) {
    
    } catch (NoSuchMethodException noSuchMethodException) {
    
    } catch (IllegalArgumentException illegalArgumentException) {
    
    } catch (IllegalAccessException illegalAccessException) {
    
    } catch (InvocationTargetException invocationTargetException) {}
  }
  
  protected long getLastAddress(PartitionItem part) {
    List<PartitionItem> children = getBurner().getPratitionInfo().getChildren();
    if (!children.contains(part))
      return 0L; 
    long address = 0L;
    for (PartitionItem item : children) {
      if (item == part)
        return address; 
      if (part.getFlashType() == item.getFlashType()) {
        address = item.getStart();
        if (item.getLength() > 0L)
          address += item.getLength(); 
      } 
    } 
    return 0L;
  }
  
  protected void updateFlashTypeAddress(PartitionItem part, FlashType oldType) {
    part.setStart(getLastAddress(part));
    updateAddresses(part);
    long address = 0L;
    for (PartitionItem item : getBurner().getPratitionInfo().getChildren()) {
      if (item.getFlashType() != oldType)
        continue; 
      if (address == 0L) {
        address = item.getStart();
      } else {
        item.setStart(address);
      } 
      address += item.getLength();
    } 
    this.itemViewer.refresh();
  }
  
  protected void updateAddresses(PartitionItem part) {
    long address = 0L;
    for (PartitionItem item : getBurner().getPratitionInfo().getChildren()) {
      if (address > 0L && item.getFlashType() == part.getFlashType()) {
        item.setStart(address);
        if (item.getLength() > 0L)
          address += item.getLength(); 
      } 
      if (item == part)
        address = part.getStart() + ((part.getLength() < 0L) ? 0L : part.getLength()); 
    } 
    this.itemViewer.refresh();
  }
  
  protected void updateAddressesForAddNew(PartitionItem part, int index) {
    List<PartitionItem> children = getBurner().getPratitionInfo().getChildren();
    PartitionItem item = children.get(index);
    long address = item.getStart();
    if (item.getLength() > 0L)
      address += item.getLength(); 
    for (int i = index + 1; i < children.size(); i++) {
      item = children.get(i);
      if (item.getFlashType() == part.getFlashType()) {
        item.setStart(address);
        if (item.getLength() > 0L)
          address += item.getLength(); 
      } 
    } 
    this.itemViewer.refresh();
  }
  
  public void finished(FastbootEvent event) {
    super.finished(event);
    if (this.itemViewer != null)
      this.itemViewer.setSelection((ISelection)new StructuredSelection()); 
  }
  
  protected void disableUI() {
    if (this.burnButton != null && !this.burnButton.isDisposed())
      this.burnButton.setEnabled(false); 
    if (this.eraseButton != null && !this.eraseButton.isDisposed())
      this.eraseButton.setEnabled(false); 
    if (this.eraseAllButton != null && !this.eraseAllButton.isDisposed())
      this.eraseAllButton.setEnabled(false); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(false); 
    if (this.saveButton != null && !this.saveButton.isDisposed())
      this.saveButton.setEnabled(false); 
    if (this.programmerFileBrowseButton != null && 
      !this.programmerFileBrowseButton.isDisposed())
      this.programmerFileBrowseButton.setEnabled(false); 
    if (this.createUsbPackageButton != null && 
      !this.createUsbPackageButton.isDisposed())
      this.createUsbPackageButton.setEnabled(false); 
    if (this.makeNandImageButton != null && !this.makeNandImageButton.isDisposed())
      this.makeNandImageButton.setEnabled(false); 
  }
  
  protected void enableButtons() {
    if (this.burnButton != null && !this.burnButton.isDisposed())
      this.burnButton.setEnabled(true); 
    if (this.eraseButton != null && !this.eraseButton.isDisposed())
      this.eraseButton.setEnabled(true); 
    if (this.eraseAllButton != null && !this.eraseAllButton.isDisposed())
      this.eraseAllButton.setEnabled(true); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(true); 
    if (this.saveButton != null && !this.saveButton.isDisposed())
      this.saveButton.setEnabled(true); 
    if (this.programmerFileBrowseButton != null && 
      !this.programmerFileBrowseButton.isDisposed())
      this.programmerFileBrowseButton.setEnabled(true); 
    if (this.createUsbPackageButton != null && 
      !this.createUsbPackageButton.isDisposed())
      this.createUsbPackageButton.setEnabled(true); 
    if (this.makeNandImageButton != null && !this.makeNandImageButton.isDisposed())
      this.makeNandImageButton.setEnabled(true); 
  }
  
  protected void enableUI() {
    enableButtons();
  }
  
  public void hightLight(List<PartitionItem> parts) {
    if (parts.isEmpty())
      return; 
    if (!isDisposed() && 
      this.itemViewer != null) {
      this.itemViewer.setSelection((ISelection)new StructuredSelection(parts), true);
      this.itemViewer.getControl().getParent().setFocus();
    } 
  }
  
  public int promptToSave(boolean canCancel) {
    int open = 0;
    if (isDisposed())
      return open; 
    if (isDirty()) {
      BurnState state = BurnState.INSTANCE;
      IPartitionBurner burner = getBurner();
      String fileContent = PartitionItem.getFileContent(getBurner().getPratitionInfo()
          .getChildren(), burner.getPratitionInfo().getProgrammerFile());
      File partitionFile = burner.getPartitionFile();
      if (burner instanceof com.vendor.burn.model.devices.IEmmcBurner) {
        state.setEmmcParitionPath(partitionFile);
        state.setEmmcPartitionContent(fileContent);
      } else {
        state.setPartitionPath(partitionFile);
        state.setPartitionContent(fileContent);
      } 
    } 
    return open;
  }
  
  public IPartitionBurner getBurner() {
    return (IPartitionBurner)super.getBurner();
  }
  
  protected void handleBrwoseProgrammerFile() {
    FileDialog dialog = new FileDialog(getShell(), 4096);
    String text = this.programmerFileText.getText();
    if (!text.equals(""))
      dialog.setFileName(text); 
    String filePath = dialog.open();
    if (filePath != null) {
      this.programmerFileText.setText(filePath);
      File bootFile = new File(filePath);
      if (bootFile.exists()) {
        ((AbstractBurner)getBurner()).setProgrammerFile(filePath);
      } else {
        ((AbstractBurner)getBurner()).setProgrammerFile(null);
      } 
    } 
  }
  
  protected void handleCreateNandImage() {
    ToolStatistics.INSTANCE.logUsage("BurnTool", "Create Nand Image By Partition", "ChipName: " + this.burner
        
        .getBurnContext().getDeviceSetting().getName());
    ToolStatistics.INSTANCE.logToolInUse("BurnTool");
    IDeviceSetting deviceSetting = getBurner().getBurnContext().getDeviceSetting();
    if (deviceSetting == null) {
      MessageDialog.openInformation(
          Display.getCurrent().getActiveShell(), "BurnTool", Messages.PartitionComposite_MakeNandImage_DoNotSupport);
      return;
    } 
    UnknownDevice device = (UnknownDevice)deviceSetting;
    if (device.getNandIPVer() != 500 && device.getNandIPVer() != 600 && device
      .getNandIPVer() != 610 && device
      .getNandIPVer() != 611 && device
      .getNandIPVer() != 620)
      if (device.getSpinandIPVer() != 500 && device
        .getSpinandIPVer() != 600 && device
        .getSpinandIPVer() != 610 && device
        .getSpinandIPVer() != 611 && device
        .getSpinandIPVer() != 620) {
        MessageDialog.openInformation(Display.getCurrent()
            .getActiveShell(), "BurnTool", Messages.NandImage_DoNotSupport);
        return;
      }  
    NandIPCommon nandSet = null;
    if (device.getNandIPVer() != -1 && device.getSpinandIPVer() != -1) {
      SelectNandImageDialog selectNandImageDialog = new SelectNandImageDialog(Display.getCurrent().getActiveShell());
      int open = selectNandImageDialog.open();
      if (open == 0) {
        String selectedNandWay = selectNandImageDialog.getSelectNandImageWay();
        if (selectedNandWay.equals("Nand")) {
          nandSet = NandIPCommon.chooseNandVersion(device);
        } else if (selectedNandWay.equals("SPINand")) {
          nandSet = NandIPCommon.chooseSPINandVersion(device);
        } 
        if (nandSet != null)
          nandSet.setCurSelectedNandWay(selectedNandWay); 
      } else {
        return;
      } 
    } else if (device.getNandIPVer() != -1) {
      nandSet = NandIPCommon.chooseNandVersion(device);
      if (nandSet != null)
        nandSet.setCurSelectedNandWay("Nand"); 
    } else if (device.getSpinandIPVer() != -1) {
      nandSet = NandIPCommon.chooseSPINandVersion(device);
      if (nandSet != null)
        nandSet.setCurSelectedNandWay("SPINand"); 
    } else {
      nandSet = NandIPCommon.chooseNandVersion(device);
      if (nandSet != null)
        nandSet.setCurSelectedNandWay("Nand"); 
    } 
    if (nandSet == null)
      return; 
    NandImageDialog dialog = new NandImageDialog(Display.getCurrent().getActiveShell(), 67680, nandSet, this.burner);
    dialog.open();
    FlashOption option = dialog.getSelectedFlashOption();
    NandIPCommon nandSetting = nandSet;
    int blockSize = dialog.getBlockSize();
    if (option == null)
      return; 
    boolean isSelectRandom = dialog.isSelectRandom();
    DirectoryDialog outputSelectDialog = new DirectoryDialog(Display.getCurrent().getActiveShell());
    outputSelectDialog.setText(Messages.NandImageDialog_DstFolder);
    outputSelectDialog.setMessage(Messages.NandImageDialog_DstFolderSelect);
    if (saveNandImgPath != null)
      outputSelectDialog.setFilterPath(saveNandImgPath); 
    String path = outputSelectDialog.open();
    if (path == null)
      return; 
    saveNandImgPath = path;
    disableUI();
    IFastbootProgressMonitor fastbootMonitor = getProgressMonitor();
    Object object = new Object(this, "Create Nand Burner Image...", nandSetting, path, option, blockSize, isSelectRandom, fastbootMonitor);
    object.addJobChangeListener((IJobChangeListener)new Object(this));
    object.setUser(true);
    object.schedule();
  }
  
  private boolean isCanModify(String property, PartitionItem value, String chipName) {
    return true;
  }
  
  String getRealString(String realFileName, int total) {
    Font font = this.tableFileText.getFont();
    if (font == null)
      return ""; 
    Shell shell = null;
    Label label = null;
    GC gc = null;
    try {
      shell = new Shell();
      label = new Label((Composite)shell, 0);
      label.setFont(font);
      gc = new GC((Drawable)label);
      int width = getStringWidth(shell, gc, label, realFileName);
      if (total >= width)
        return realFileName; 
      StringBuilder sb = new StringBuilder(realFileName);
      while (width > total) {
        sb.delete(0, 2);
        width = getStringWidth(shell, gc, label, sb.toString());
      } 
      sb.delete(0, 3).insert(0, "...");
      return sb.toString();
    } finally {
      if (gc != null)
        gc.dispose(); 
      if (shell != null)
        shell.dispose(); 
    } 
  }
  
  private static int getStringWidth(Shell shell, GC gc, Label label, String string) {
    int width = 0;
    for (int i = 0; i < string.length(); i++) {
      char c = string.charAt(i);
      width += gc.getAdvanceWidth(c);
    } 
    return width;
  }
  
  public void setTabItem(TabItem tabItem) {
    this.tabItem = tabItem;
  }
  
  public void deleteItem(CheckboxTableViewer itemViewer, TableItem itm) {
    TableItem[] items = itemViewer.getTable().getItems();
    for (int i = 0; i < items.length; i++) {
      if (items[i].equals(itm)) {
        items[i].dispose();
        items[i] = null;
        itemViewer.refresh();
      } 
    } 
  }
  
  public boolean isvBarVisibility() {
    return this.vBarVisibility;
  }
  
  public void setvBarVisibility(boolean vBarVisibility) {
    this.vBarVisibility = vBarVisibility;
  }
  
  public void refreshUiPartitionTable() {
    this.itemViewer.refresh();
  }
}
